/* Decode beacon trame balise
 *  Set outil/partition schem/No OTA 2MB APP/2MB SPIFFS
 *  Receive data from wifi beacon from emetter
 *  Send data over BLE to Android application
 *  Version 1/11/2020
 */

#include <WiFi.h>
#include <esp_wifi.h>
#include <WebServer.h>
#include <esp_event_loop.h>
#include <nvs_flash.h>
#include <BLEDevice.h>
#include <BLEUtils.h>
#include <BLEServer.h>

#define SERVICE_UUID        "4fafc201-1fb5-459e-8fcc-c5c9c331914b"
#define CHARACTERISTIC_UUID "beb5483e-36e1-4688-b7f5-ea07361b26a8"

#define LED 2 
#define ON HIGH
#define OFF LOW

static const char* const WIFI_PHY_RATE[] = 
{
  "1_Mbps_with_long_preamble",
  "2_Mbps_with_long_preamble",
  "5.5_Mbps_with_long_preamble",
  "11_Mbps_with_long_preamble",
  "",
  "2_Mbps_with_short_preamble",
  "5.5_Mbps_with_short_preamble",
  "11_Mbps_with_short_preamble",
  "48_Mbps",
  "24_Mbps",
  "12_Mbps",
  "6_Mbps",
  "54_Mbps",
  "36_Mbps",
  "18_Mbps",
  "9_Mbps",
  "MCS0_with_long_GI,_6.5_Mbps_for_20MHz,_13.5_Mbps_for_40MHz",
  "MCS1_with_long_GI,_13_Mbps_for_20MHz,_27_Mbps_for_40MHz",
  "MCS2_with_long_GI,_19.5_Mbps_for_20MHz,_40.5_Mbps_for_40MHz",
  "MCS3_with_long_GI,_26_Mbps_for_20MHz,_54_Mbps_for_40MHz",
  "MCS4_with_long_GI,_39_Mbps_for_20MHz,_81_Mbps_for_40MHz",
  "MCS5_with_long_GI,_52_Mbps_for_20MHz,_108_Mbps_for_40MHz",
  "MCS6_with_long_GI,_58.5_Mbps_for_20MHz,_121.5_Mbps_for_40MHz",
  "MCS7_with_long_GI,_65_Mbps_for_20MHz,_135_Mbps_for_40MHz",
  "MCS7_with_short_GI,_72.2_Mbps_for_20MHz,_150_Mbps_for_40MHz",
  "250_Kbps_LORA",
  "500_Kbps_LORA",
};

static const char* const WIFI_CBW[] = 
{
  "20MHz",
  "40MHz",
};


String trame = "";
//nom du point d'acces wifi 
const char ssid[] = "DECODEUR_DGAC_XAV";
// Mot de pass du wifi
const char *password = "1234567890";
// wifi channel doit être 6
const int wifi_channel=6;
//pour la puissance 
int8_t P1;

WebServer MonServeurWeb(80);
BLECharacteristic * pCharacteristic;

//gestion du serveur web
String messageinit = "...";
String tramebrute = "";
String messageinfo = "";

String ID_Balise = "...";
String TRI_constructeur = "...";
String CODE_balise = "...";
String SN_balise = "...";
String LAT_home = "...";
String LON_home = "...";
String LAT_actu = "...";
String LON_actu = "...";
String HAU_actu = "...";
String ALT_actu = "...";
String VIT_actu = "...";
String DIR_actu = "...";
double codeinfo = 0;

String CouleurTexte = "red";
String CouleurMessage = "red";

String Wifi_RSSI = "...";
String Wifi_Canal = "...";
String Wifi_Rate = "...";
String Wifi_Bande = "...";

// calcul du temps depuis dernière capture trame
unsigned long agetrame = millis();

void handleRoot()
{  
    // Page d'accueil
    String page = "<!DOCTYPE html>"; 
    page += "<head>";
    page += "    <title>Serveur " + String(ssid) + " </title>";
    page += "    <meta http-equiv='refresh' content='1' name='viewport' content='width=device-width, initial-scale=1' charset='UTF-8'/>";
    page += "</head>";
    page += "<body lang='fr'>";
    page += "    <h1 style='color:" + CouleurMessage + ";font-size:1.5vw;'>Récepteur: " + String(ssid) + " </h1>";
    page += "    <p style='color:blue;font-size:1vw;'> " + messageinit + " </p>";
    page += "    <hr>";
    page += "    <p style='color:blue;font-size:1.5vw;'>ID de la balise</p>";
    page += "    <p style='color:black;font-size:1vw;'>Trigramme constructeur: " + TRI_constructeur + " </p>";
    page += "    <p style='color:black;font-size:1vw;'>Code type de la balise: " + CODE_balise + " </p>";
    page += "    <p style='color:black;font-size:1vw;'>SN de la balise: " + SN_balise + " </p>";
    page += "    <hr>";
    page += "    <p style='color:blue;font-size:1.5vw;'>Position de départ</p>";
    page += "    <p style='color:black;font-size:1vw;'>Latitude de départ: " + LAT_home + " </p>";
    page += "    <p style='color:black;font-size:1vw;'>Longitude de départ: " + LON_home + " </p>";
    page += "    <hr>";
    page += "    <p style='color:blue;font-size:1.5vw;'>Dernière position connue</p>";
    page += "    <p style='color:black;font-size:1vw;'>Latitude: " + LAT_actu + " </p>";
    page += "    <p style='color:black;font-size:1vw;'>Longitude: " + LON_actu + " </p>";
    page += "    <p style='color:black;font-size:1vw;'>Altitude: " + ALT_actu + " </p>";
    page += "    <p style='color:black;font-size:1vw;'>Hauteur: " + HAU_actu + " </p>";
    page += "    <p style='color:black;font-size:1vw;'>Vitesse: " + VIT_actu + " </p>";
    page += "    <p style='color:black;font-size:1vw;'>Direction: " + DIR_actu + " </p>";
    page += "    <hr>";
    page += "    <p style='color:" + CouleurTexte + ";font-size:1vw;'> Dernière trame reçue depuis " + String((millis()-agetrame)/1000) + " s.</p>";
    page += "    <hr>";
    page += "    <p style='color:blue;font-size:1.5vw;'>Message</p>";
    page += "    <p style='color:" + CouleurMessage + ";font-size:1vw;'> " + messageinfo + "</p>";
    page += "    <hr>";
    page += "    <p style='color:blue;font-size:1.5vw;'>Information Wifi balise</p>";
    page += "    <p style='color:black;font-size:1vw;'>RSSI: " + Wifi_RSSI + " </p>";
    page += "    <p style='color:black;font-size:1vw;'>Largeur de bande: " + Wifi_Bande + " </p>";
    page += "    <p style='color:black;font-size:1vw;'>Vitesse d'émission: " + Wifi_Rate + " </p>";
    page += "    <p style='color:black;font-size:1vw;'>Canal: " + Wifi_Canal + " </p>";
    page += "    <hr>";
    page += "    <p style='color:blue;font-size:1.5vw;'>Trame brute</p>";
    page += "    <p style='color:black;font-size:1vw;'> " + tramebrute + "</p>";
    page += "    <hr>";
    page += "</body>";
    page += "</html>";  // Fin page HTML

    MonServeurWeb.send(200, "text/html", page);  // Envoie de la page HTML
}

void handleNotFound()
{
  MonServeurWeb.send(404, "text/plain","404: Not found");
}

boolean InitWeb()
{
  MonServeurWeb.on("/", HTTP_GET, handleRoot);  // Chargement de la page d'accueil
  MonServeurWeb.onNotFound(handleNotFound);  // Chargement de la page "Not found"
  MonServeurWeb.begin();  // Initialisation du serveur web
  return true;
}

/**
  * Enumeration des types de données à envoyer
*/
enum DATA_TYPE: uint8_t 
{
  RESERVED = 0,
  PROTOCOL_VERSION = 1,
  ID_FR = 2,
  ID_ANSI_CTA = 3,
  LATITUDE = 4,        // In WS84 in degree * 1e5
  LONGITUDE = 5,       // In WS84 in degree * 1e5
  ALTITUDE = 6,        // In MSL in m
  HEIGTH = 7,          // From Home in m
  HOME_LATITUDE = 8,   // In WS84 in degree * 1e5
  HOME_LONGITUDE = 9,  // In WS84 in degree * 1e5
  GROUND_SPEED = 10,   // In m/s
  HEADING = 11,        // Heading in degree from north 0 to 359.
  CODEINFO = 12,        // code info
  NOT_DEFINED_END = 13,
};

/**
  * Tableau TLV (TYPE, LENGTH, VALUE) avec les tailles attendu des différents type données.
***/
static constexpr uint8_t TLV_LENGTH[] 
{
  0,  // [DATA_TYPE::RESERVED]
  1,  // [DATA_TYPE::PROTOCOL_VERSION]
  30, // [DATA_TYPE::ID_FR]
  0,  // [DATA_TYPE::ID_ANSI_CTA]
  4,  // [DATA_TYPE::LATITUDE]
  4,  // [DATA_TYPE::LONGITUDE]
  2,  // [DATA_TYPE::ALTITUDE]
  2,  // [DATA_TYPE::HEIGTH]
  4,  // [DATA_TYPE::HOME_LATITUDE]
  4,  // [DATA_TYPE::HOME_LONGITUDE]
  1,  // [DATA_TYPE::GROUND_SPEED]
  2,  // [DATA_TYPE::HEADING]
  1,  // [DATA_TYPE::CODEINFO]
};


typedef struct 
{
  unsigned frame_ctrl:16;
  unsigned duration_id:16;
  uint8_t addr1[6]; /* receiver address */
  uint8_t addr2[6]; /* sender address */
  uint8_t addr3[6]; /* filtering address */
  unsigned sequence_ctrl:16;
  uint8_t addr4[6]; /* optional */
} wifi_ieee80211_mac_hdr_t;


typedef struct  
{
  int16_t fctl;
  int16_t duration;
  uint8_t da;
  uint8_t sa;
  uint8_t bssid;
  int16_t seqctl;
  unsigned char payload[];
} __attribute__((packed)) WifiMgmtHdr;

typedef struct 
{
  WifiMgmtHdr hdr;
  uint8_t payload[0];
} wifi_ieee80211_packet_t;

static esp_err_t event_handler(void *ctx, system_event_t *event);
static void wifi_sniffer_init(void);
static void wifi_sniffer_set_channel(uint8_t channel);
static const char *wifi_sniffer_packet_type2str(wifi_promiscuous_pkt_type_t type);
static void wifi_sniffer_packet_handler(void *buff, wifi_promiscuous_pkt_type_t type);

esp_err_t event_handler(void *ctx, system_event_t *event)
{
  return ESP_OK;
}

void wifi_sniffer_init(void)
{
  nvs_flash_init();
  tcpip_adapter_init();
  ESP_ERROR_CHECK( esp_event_loop_init(event_handler, NULL) );
  wifi_init_config_t cfg = WIFI_INIT_CONFIG_DEFAULT();
  ESP_ERROR_CHECK( esp_wifi_init(&cfg) );
  ESP_ERROR_CHECK( esp_wifi_set_storage(WIFI_STORAGE_RAM) );
  ESP_ERROR_CHECK( esp_wifi_set_mode(WIFI_MODE_NULL) );
  //ESP_ERROR_CHECK(esp_wifi_set_bandwidth(ESP_IF_WIFI_AP, WIFI_BW_HT20));
  esp_wifi_set_promiscuous(true);
  esp_wifi_set_promiscuous_rx_cb(&beaconCallback);
  ESP_ERROR_CHECK( esp_wifi_start() );
  
}

void wifi_sniffer_set_channel(uint8_t channel)
{
  esp_wifi_set_channel(channel, WIFI_SECOND_CHAN_NONE);
}

// Function to extract MAC addr from a packet at given offset
void getMAC(char *addr, uint8_t* data, uint16_t offset) 
{
  sprintf(addr, "%02x:%02x:%02x:%02x:%02x:%02x", data[offset+0], data[offset+1], data[offset+2], data[offset+3], data[offset+4], data[offset+5]);
}

String donneCoordonnees(uint16_t start, int len, uint16_t size, uint8_t* data) 
{
  uint8_t count = size-1;
  int data_value = 0;
  //Serial.print(" data_value="); Serial.print(data_value); Serial.print(" neg=");
  bool neg_number = data[start] > 0x7F;
  //Serial.print(neg_number);Serial.print(" ");
  
  for(uint16_t i = start; i < len && i < start+size; i++) 
  {
    //Serial.print(count); Serial.print("-");  
    data_value +=  (data[i]) << (8 * count); 
    count--;
  }
  
  if(neg_number) 
  {
    data_value = (0xFFFFFFFF & ~data_value) + 1; 
    data_value *= -1;
  }
  
  //Serial.print(double(data_value) * 0.00001 , 5);
  //trame += String(double(data_value) * 0.00001,5);
  return String(double(data_value) * 0.00001,5);
}

String donneAltitude(uint16_t start, int len, uint16_t size, uint8_t* data)
{
  uint8_t count = size-1;
  int data_value = 0;
  bool neg_number = data[start] > 0x7F;
  //Serial.print(neg_number);Serial.print(" ");
  
  for(uint16_t i = start; i < len && i < start+size; i++) 
  {
    //Serial.print(count); Serial.print("-");  
    data_value +=  (data[i]) << (8 * count); 
    count--;
  }
  
  if(neg_number) 
  {
    data_value = (0xFFFF & ~data_value) + 1; 
    data_value *= -1;
  }
  
  //Serial.print(data_value);
  //trame = trame + String(data_value);
  return String(data_value);
}

static void recupID_balise(uint16_t start, int len, uint16_t size, uint8_t* data) 
{
  ID_Balise = "";
  for(uint16_t i = start; i < len && i < start+size; i++) 
  {
    ID_Balise = ID_Balise + char(data[i]);
  }
  //découpe l'id:
  TRI_constructeur = ID_Balise.substring(0,3);
  CODE_balise = ID_Balise.substring(3,6);
  SN_balise = ID_Balise.substring(6);
}

// la fonction callback s'exécute seulement si un paquet est reçu sur le canal 6
void beaconCallback(void* buf, wifi_promiscuous_pkt_type_t type)
{
  wifi_promiscuous_pkt_t *snifferPacket = (wifi_promiscuous_pkt_t*)buf;
  WifiMgmtHdr *frameControl = (WifiMgmtHdr*)snifferPacket->payload;
  //wifi_pkt_rx_ctrl_t ctrl = (wifi_pkt_rx_ctrl_t)snifferPacket->rx_ctrl; //inutile pas utilisé ensuite
  int len = snifferPacket->rx_ctrl.sig_len;
  uint8_t SSID_length = (int)snifferPacket->payload[40];
  uint8_t offset_OUI = 42+SSID_length;
  //Organizationally Unique Identifier = 6A:5C:35 = Secrétariat général de la défense et de la sécurité nationale
  const uint8_t FRAME_OUI[3] = {0x6A, 0x5C, 0x35};
  
  //Filter OUI from 6A:5C:35
  if(snifferPacket->payload[offset_OUI+1] != FRAME_OUI[0] && snifferPacket->payload[offset_OUI+2] != FRAME_OUI[1] && snifferPacket->payload[offset_OUI+3] != FRAME_OUI[2])  
  {
    if (millis() > (agetrame + 6000)) 
    {
      Serial.print("plus de trame reçue depuis + de 6s: ");Serial.print((millis()-agetrame)/1000);Serial.println(" s");
      CouleurTexte = "red";
      CouleurMessage = "red";
      digitalWrite(LED, OFF);
    }
    return;
  }
  
  len -= 4;
  int fctl = ntohs(frameControl->fctl);
  const wifi_ieee80211_packet_t *ipkt = (wifi_ieee80211_packet_t *)snifferPacket->payload;
  const WifiMgmtHdr *hdr = &ipkt->hdr;
  
  // If we dont the buffer size is not 0, don't write or else we get CORRUPT_HEAP
  if (snifferPacket->payload[0] == 0x80)
  {
    Serial.print("len=");Serial.println(len,DEC);
    
    // ID balise
    trame += "ID=";
    recupID_balise(offset_OUI+4+6, len, TLV_LENGTH[ID_FR] , snifferPacket->payload);
    trame += ID_Balise;

    // Latitude
    uint16_t offset = offset_OUI+4+6+TLV_LENGTH[ID_FR]+2; // +2 : Type + Length
    trame += " lat=";
    LAT_actu = donneCoordonnees(offset, len, TLV_LENGTH[LATITUDE] , snifferPacket->payload);
    trame += LAT_actu;

    // Longitude
    offset += TLV_LENGTH[LATITUDE]+2;
    trame += " long=";  
    LON_actu = donneCoordonnees(offset, len, TLV_LENGTH[LONGITUDE] , snifferPacket->payload);
    trame += LON_actu;

    //Altitude msl
    offset += TLV_LENGTH[LONGITUDE]+2;
    trame += " alt=";
    ALT_actu = donneAltitude(offset, len, TLV_LENGTH[ALTITUDE] , snifferPacket->payload); 
    trame += ALT_actu;

    //hauteur    
    offset += TLV_LENGTH[ALTITUDE]+2;
    trame += " Hauteur="; 
    HAU_actu = donneAltitude(offset, len, TLV_LENGTH[HEIGTH] , snifferPacket->payload); 
    trame += HAU_actu;

    //home latitude    
    offset += TLV_LENGTH[HEIGTH]+2;
    trame += " lat_dep=";
    LAT_home = donneCoordonnees(offset, len, TLV_LENGTH[HOME_LATITUDE] , snifferPacket->payload);
    trame += LAT_home;

    //home longitude
    offset += TLV_LENGTH[HOME_LATITUDE]+2;
    trame += " long_dep=";
    LON_home = donneCoordonnees(offset, len, TLV_LENGTH[HOME_LONGITUDE] , snifferPacket->payload);
    trame += LON_home;

    //ground speed
    offset += TLV_LENGTH[HOME_LONGITUDE]+2; 
    trame += " Vitesse=";
    VIT_actu = donneAltitude(offset, len, TLV_LENGTH[GROUND_SPEED] , snifferPacket->payload); 
    trame += VIT_actu;

    //heading
    offset += TLV_LENGTH[GROUND_SPEED]+2;
    trame += " Dir=";
    DIR_actu = donneAltitude(offset, len, TLV_LENGTH[HEADING] , snifferPacket->payload); 
    trame += DIR_actu;

    //CODEINFO
    offset += TLV_LENGTH[HEADING]+2;
    trame += " CodeInfo=";
    messageinfo = donneAltitude(offset, len, TLV_LENGTH[CODEINFO] , snifferPacket->payload); 
    trame += String(messageinfo);

    //préparation du message d'info pour le site web maintenant qu'on a stocké le code info dans la trame:
    //couleur rouge par défaut car plus de cas rouges...
    CouleurMessage = "red";
    int codetempo = messageinfo.toInt();
    switch (codetempo) 
    {
      case 0:
        messageinfo = "Initialisation en cours...";
        break;
      case 1:
        messageinfo = "GPS non détecté, aucune donnée GPS reçue";
        break;
      case 2:
        messageinfo = "Positionnement du GPS non valide (fix en cours)";
        break;
      case 3:
        messageinfo = "Fix du GPS perdu...";
        break;
      case 4:
        messageinfo = "Le nombre de satellites captés est trop faible";
        break;
      case 5:
        messageinfo = "La précision GPS est trop faible";
        break;
      case 6:
        messageinfo = "L'altitude est indéfinie";
        break;
      case 7:
        messageinfo = "Stockage de la position de départ OK";
        CouleurMessage = "green";
        break;
      case 8:
        messageinfo = "cas non prévu!!!";
        break;
      case 9:
        messageinfo = "Dernière trame reçue valide";
        //le seul cas où le message est vert
        CouleurMessage = "green";
      break;
      default:
        messageinfo = "cas non prévu!!!";
        break;
    }

    //infos wifi
    //on récuup les infos wifi pour le site
    //Wifi_RSSI Wifi_Canal  Wifi_Rate Wifi_Bande
    Wifi_RSSI = String(snifferPacket->rx_ctrl.rssi);
    Wifi_Bande = String(WIFI_CBW[snifferPacket->rx_ctrl.cwb]);
    Wifi_Rate = String(WIFI_PHY_RATE[snifferPacket->rx_ctrl.rate]);
    Wifi_Canal = String(snifferPacket->rx_ctrl.channel);
    
    Serial.print("RSSI=");Serial.println(Wifi_RSSI);
    Serial.print("Largeur=");Serial.println(Wifi_Bande);
    Serial.print("Rate=");Serial.println(Wifi_Rate);
    Serial.print("Canal=");Serial.println(Wifi_Canal);

    //et pour le BT
    //RSSI
    trame += " RSSI=";
    trame += String(Wifi_RSSI);
    //Largeur de bande
    trame += " Largeur=";
    trame += String(Wifi_Bande);
    //Vitesse
    trame += " Rate=";
    trame += String(Wifi_Rate);
    //Canal
    trame += " Canal=";
    trame += String(Wifi_Canal);

    //visu de la trame
    Serial.println(trame);
    //c'est ici qu'on peut envoyer la trame au site web
    tramebrute = trame;
    //envoi au BT:
    pCharacteristic->setValue(trame.c_str());
    pCharacteristic->notify();
    //puis on la vide...
    trame="";
    
    Serial.println("--------------------------");

    // ici réinit le compteur d'age
    agetrame = millis();
    CouleurTexte = "green";
    
    //selon codeinfo on fait varier la vitesse de la led:
    int compteur = 0;
    if (codetempo == 9)
    {
      //led bleue rythme rock'n'roll, tout est ok
      compteur = 8;
      while(compteur > 0)
      {
        digitalWrite(LED, ON);
        delay(25);
        digitalWrite(LED, OFF);
        delay(25);
        compteur--;
        digitalWrite(LED, ON);
      }
    }
    else
    {
      //led bleue rythme slow, souci
      compteur = 4;
      while(compteur > 0)
      {
        digitalWrite(LED, ON);
        delay(50);
        digitalWrite(LED, OFF);
        delay(50);
        compteur--;
        digitalWrite(LED, ON);
      }
    }
  }
}

// the setup function runs once when you press reset or power the board
void setup() 
{
  // initialize digital pin LED_BUILTIN as an output.
    pinMode(LED, OUTPUT);
  
    Serial.begin(115200);
    //led bleue démarrage
    int compteur = 4;
    while(compteur > 0)
    {
      digitalWrite(LED, ON);
      delay(250);
      digitalWrite(LED, OFF);
      delay(250);
      compteur--;
    }

    digitalWrite(LED, OFF);
    //initialisation du BLE
    BLEDevice::setMTU(150);
    BLEDevice::init("recepteur_DGAC");
    BLEServer *pServer = BLEDevice::createServer();
    BLEService *pService = pServer->createService(SERVICE_UUID);
    pCharacteristic = pService->createCharacteristic(
                                           CHARACTERISTIC_UUID,
                                           BLECharacteristic::PROPERTY_READ |
                                           BLECharacteristic::PROPERTY_WRITE
                                         );
    pService->start();
    // BLEAdvertising *pAdvertising = pServer->getAdvertising();  // this still is working for backward compatibility
    BLEAdvertising *pAdvertising = BLEDevice::getAdvertising();
    pAdvertising->addServiceUUID(SERVICE_UUID);
    pAdvertising->setScanResponse(true);
    pAdvertising->setMinPreferred(0x06);  // functions that help with iPhone connections issue
    pAdvertising->setMinPreferred(0x12);
    BLEDevice::startAdvertising();

    //init wifi
    Serial.println("--------------------------");
    Serial.println("Mise en place du wifi:");
    //messageinit = ("Mise en place du wifi en cours...");messageinit+="<br>";
    // init du sniffer wifi sur channel 6
    wifi_sniffer_init();
    wifi_sniffer_set_channel(wifi_channel);
    //démarrage
    WiFi.mode(WIFI_AP);
    //infos sur le wifi:
    if (WiFi.softAP(ssid, password, wifi_channel, false)==false)  // ssid, pwd, channel, hidden (facultatif), max_cnx (facultatif, de 0 à 8, 4 par défaut)
    {
      Serial.print("ECHEC de mise en place du wifi, dont le nom est: ");Serial.println(ssid);
      return;
    }
    //infos sur le wifi:
    Serial.print("Nom du récepteur: ");Serial.println(ssid);
    //attente init correcte du wifi:
    delay(500);
    //messageinit = ("Mise en place du wifi Ok");messageinit+="<br>";

     // autres paramétrages, adresse ip fixée pour avoir toujours la même:
    IPAddress Ip(192, 168, 1, 1);
    IPAddress NMask(255, 255, 255, 0);
    WiFi.softAPConfig(Ip, Ip, NMask);
  
    //affichage des infos
    IPAddress myIP = WiFi.softAPIP();
    Serial.print("Adresse IP du récepteur: ");
    Serial.println(myIP.toString());
    //messageinit += ("Adresse IP du récepteur: ");messageinit += myIP.toString();messageinit+="<br>";
    Serial.print("Adresse MAC du récepteur: ");
    Serial.println(WiFi.macAddress());
    messageinit = ("Adresse MAC: ");messageinit += WiFi.macAddress();messageinit+="<br>";
    // vérifier de la puissance d'émission
    esp_err_t r = esp_wifi_get_max_tx_power(&P1);
    Serial.print("Puissance de transmission (dBm): ");Serial.println(P1*0.25);
    Serial.println("--------------------------");
    
    // démarrage du serveur web
    if (!InitWeb()) 
    {
      Serial.println("Erreur démarrage site web");
      digitalWrite(LED, OFF);
    }
    else
    {
      Serial.print("Serveur web récepteur actif sur http://");Serial.print(myIP);Serial.println("/");
      //messageinit += ("Serveur web récepteur actif sur http://");messageinit += myIP.toString();messageinit += ("/");messageinit+="<br>";
    }
    Serial.println("--------------------------");
    Serial.println("En attente de trames...");
  
}

// the loop function runs over and over again forever
void loop() 
{
   //gestion serveur web
   MonServeurWeb.handleClient();  // Attente de demande du client
   //digitalWrite(LED, OFF);
}
